// pmf2mi, Polish Map Format to MapInfo Converter
// Version 1.0 alpha 1
// (C) 2003 by Olexa Riznyk (www.olexa.com.ua)

var sVersion = "1.0 alpha 1";
var sSplash = "pmf2mi, Polish Map Format to MapInfo Converter\n"
	+ "Version " + sVersion + "\n"
	+ "(C) 2003 by Olexa Riznyk (www.olexa.com.ua)\n";
var sHelp = sSplash
	+ "\n"
	+ "Usage: pmf2mi <source_file> [<destination_folder>]\n"
	+ "\n"
	+ "<source_file>		Source file name, it sould be in cGPSmapper text format\n"
	+ "			(so-called Polish Map Format)\n"
	+ "<destination_folder>	Destination folder name; by default, current folder\n"
	;
//--------------------------------
var SectionsProcessed, NodesProcessed;
var POIsProcessed, CitiesPointsProcessed, PolylinesProcessed, RegionsProcessed;
var CurrentStatus = "";

var MaxOpenedTablesCnt = 12;
var OpenedTablesCnt = 0;
var CreatedTables = new Array();
var Styles = new Array();
Styles[0x400000 + 0x01] = {Width: 3, Pattern: 2, Red: 0, Green: 0, Blue: 255, Layer: "Roads"};
Styles[0x400000 + 0x02] = {Width: 3, Pattern: 2, Red: 255, Green: 0, Blue: 0, Layer: "Roads"};
Styles[0x400000 + 0x03] = {Width: 2, Pattern: 2, Red: 255, Green: 0, Blue: 0, Layer: "Roads"};
Styles[0x400000 + 0x04] = {Width: 2, Pattern: 2, Red: 0, Green: 0, Blue: 0, Layer: "Roads"};
Styles[0x400000 + 0x05] = {Width: 1, Pattern: 2, Red: 0, Green: 0, Blue: 0, Layer: "Roads"};
Styles[0x400000 + 0x06] = {Width: 1, Pattern: 2, Red: 64, Green: 64, Blue: 64, Layer: "Roads"};
Styles[0x400000 + 0x07] = {Width: 1, Pattern: 2, Red: 64, Green: 64, Blue: 64, Layer: "Roads"};
Styles[0x400000 + 0x08] = {Width: 3, Pattern: 2, Red: 128, Green: 128, Blue: 128, Layer: "Roads"};
Styles[0x400000 + 0x09] = {Width: 3, Pattern: 2, Red: 128, Green: 128, Blue: 128, Layer: "Roads"};
Styles[0x400000 + 0x0a] = {Width: 1, Pattern: 2, Red: 64, Green: 64, Blue: 64, Layer: "Roads"};
Styles[0x400000 + 0x0b] = {Width: 3, Pattern: 2, Red: 64, Green: 64, Blue: 64, Layer: "Roads"};
Styles[0x400000 + 0x0c] = {Width: 1, Pattern: 2, Red: 0, Green: 0, Blue: 0, Layer: "Roads"};
Styles[0x400000 + 0x14] = {Width: 1, Pattern: 26, Red: 0, Green: 0, Blue: 0, Layer: "Roads"};
Styles[0x400000 + 0x15] = {Width: 1, Pattern: 2, Red: 0, Green: 0, Blue: 0, Layer: "Roads"};
Styles[0x400000 + 0x16] = {Width: 1, Pattern: 2, Red: 0, Green: 0, Blue: 0, Layer: "Roads"};
Styles[0x400000 + 0x18] = {Width: 1, Pattern: 2, Red: 60, Green: 157, Blue: 255, Layer: "Water"};
Styles[0x400000 + 0x19] = {Width: 1, Pattern: 2, Red: 0, Green: 0, Blue: 0, Layer: "Roads"};
Styles[0x400000 + 0x1a] = {Width: 1, Pattern: 7, Red: 0, Green: 0, Blue: 0, Layer: "Roads"};
Styles[0x400000 + 0x1b] = {Width: 1, Pattern: 7, Red: 0, Green: 0, Blue: 0, Layer: "Roads"};
Styles[0x400000 + 0x1c] = {Width: 2, Pattern: 2, Red: 128, Green: 128, Blue: 128, Layer: "Admin"};
Styles[0x400000 + 0x1d] = {Width: 2, Pattern: 2, Red: 128, Green: 128, Blue: 128, Layer: "Admin"};
Styles[0x400000 + 0x1e] = {Width: 2, Pattern: 2, Red: 128, Green: 128, Blue: 128, Layer: "Admin"};
Styles[0x400000 + 0x1f] = {Width: 1, Pattern: 2, Red: 60, Green: 157, Blue: 255, Layer: "Water"};
Styles[0x400000 + 0x20] = {Width: 1, Pattern: 2, Red: 185, Green: 148, Blue: 102, Layer: "Relief"};
Styles[0x400000 + 0x21] = {Width: 2, Pattern: 2, Red: 185, Green: 148, Blue: 102, Layer: "Relief"};
Styles[0x400000 + 0x22] = {Width: 3, Pattern: 2, Red: 185, Green: 148, Blue: 102, Layer: "Relief"};
Styles[0x400000 + 0x23] = {Width: 1, Pattern: 2, Red: 0, Green: 255, Blue: 255, Layer: "Relief"};
Styles[0x400000 + 0x24] = {Width: 2, Pattern: 2, Red: 0, Green: 255, Blue: 255, Layer: "Relief"};
Styles[0x400000 + 0x25] = {Width: 3, Pattern: 2, Red: 0, Green: 255, Blue: 255, Layer: "Relief"};
Styles[0x400000 + 0x26] = {Width: 1, Pattern: 7, Red: 60, Green: 157, Blue: 255, Layer: "Water"};
Styles[0x400000 + 0x27] = {Width: 1, Pattern: 2, Red: 0, Green: 0, Blue: 0, Layer: "Aviation"};
Styles[0x400000 + 0x28] = {Width: 1, Pattern: 2, Red: 0, Green: 0, Blue: 0, Layer: "Roads"};
Styles[0x400000 + 0x29] = {Width: 1, Pattern: 2, Red: 0, Green: 0, Blue: 0, Layer: "Roads"};
Styles[0x400000 + 0x2a] = {Width: 1, Pattern: 2, Red: 0, Green: 0, Blue: 0, Layer: "Admin"};
Styles[0x400000 + 0x2b] = {Width: 1, Pattern: 2, Red: 255, Green: 0, Blue: 0, Layer: "Admin"};
Styles[0x800000 + 0x01] = {Pattern: 2, Red: 235, Green: 235, Blue: 235, Layer: "Admin"};
Styles[0x800000 + 0x02] = {Pattern: 2, Red: 235, Green: 235, Blue: 235, Layer: "Admin"};
Styles[0x800000 + 0x03] = {Pattern: 2, Red: 235, Green: 235, Blue: 235, Layer: "Admin"};
Styles[0x800000 + 0x04] = {Pattern: 2, Red: 255, Green: 255, Blue: 255, Layer: "Manmade"};
Styles[0x800000 + 0x05] = {Pattern: 2, Red: 255, Green: 255, Blue: 255, Layer: "Manmade"};
Styles[0x800000 + 0x06] = {Pattern: 2, Red: 255, Green: 255, Blue: 255, Layer: "Manmade"};
Styles[0x800000 + 0x07] = {Pattern: 2, Red: 255, Green: 255, Blue: 255, Layer: "Manmade"};
Styles[0x800000 + 0x08] = {Pattern: 2, Red: 255, Green: 255, Blue: 255, Layer: "Manmade"};
Styles[0x800000 + 0x09] = {Pattern: 2, Red: 255, Green: 255, Blue: 255, Layer: "Manmade"};
Styles[0x800000 + 0x0a] = {Pattern: 2, Red: 255, Green: 255, Blue: 255, Layer: "Manmade"};
Styles[0x800000 + 0x0b] = {Pattern: 2, Red: 255, Green: 255, Blue: 255, Layer: "Manmade"};
Styles[0x800000 + 0x0c] = {Pattern: 2, Red: 255, Green: 255, Blue: 255, Layer: "Manmade"};
Styles[0x800000 + 0x0d] = {Pattern: 2, Red: 255, Green: 240, Blue: 210, Layer: "Reservations"};
Styles[0x800000 + 0x0e] = {Pattern: 2, Red: 128, Green: 128, Blue: 128, Layer: "Aviation"};
Styles[0x800000 + 0x14] = {Pattern: 2, Red: 156, Green: 243, Blue: 189, Layer: "Parks"};
Styles[0x800000 + 0x15] = {Pattern: 2, Red: 156, Green: 243, Blue: 189, Layer: "Parks"};
Styles[0x800000 + 0x16] = {Pattern: 2, Red: 156, Green: 243, Blue: 189, Layer: "Parks"};
Styles[0x800000 + 0x17] = {Pattern: 2, Red: 156, Green: 243, Blue: 189, Layer: "Parks"};
Styles[0x800000 + 0x18] = {Pattern: 2, Red: 156, Green: 243, Blue: 189, Layer: "Parks"};
Styles[0x800000 + 0x19] = {Pattern: 2, Red: 156, Green: 243, Blue: 189, Layer: "Parks"};
Styles[0x800000 + 0x1a] = {Pattern: 2, Red: 156, Green: 243, Blue: 189, Layer: "Parks"};
Styles[0x800000 + 0x1e] = {Pattern: 2, Red: 156, Green: 243, Blue: 189, Layer: "Parks"};
Styles[0x800000 + 0x1f] = {Pattern: 2, Red: 156, Green: 243, Blue: 189, Layer: "Parks"};
Styles[0x800000 + 0x28] = {Pattern: 2, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x29] = {Pattern: 1, Red: 255, Green: 255, Blue: 255, Layer: "Other"};
Styles[0x800000 + 0x32] = {Pattern: 2, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x3b] = {Pattern: 1, Red: 255, Green: 255, Blue: 255, Layer: "Other"};
Styles[0x800000 + 0x3c] = {Pattern: 2, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x3d] = {Pattern: 2, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x3e] = {Pattern: 2, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x3f] = {Pattern: 2, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x40] = {Pattern: 2, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x41] = {Pattern: 2, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x42] = {Pattern: 2, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x43] = {Pattern: 2, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x44] = {Pattern: 2, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x45] = {Pattern: 1, Red: 255, Green: 255, Blue: 255, Layer: "Other"};
Styles[0x800000 + 0x46] = {Pattern: 2, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x47] = {Pattern: 2, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x48] = {Pattern: 2, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x49] = {Pattern: 2, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x4a] = {Pattern: 1, Red: 255, Green: 255, Blue: 255, Layer: "Other"};
Styles[0x800000 + 0x4b] = {Pattern: 1, Red: 255, Green: 255, Blue: 255, Layer: "Other"};
Styles[0x800000 + 0x4c] = {Pattern: 8, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x4d] = {Pattern: 4, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x50] = {Pattern: 3, Red: 150, Green: 115, Blue: 70, Layer: "Woods"};
Styles[0x800000 + 0x51] = {Pattern: 3, Red: 106, Green: 181, Blue: 255, Layer: "Water"};
Styles[0x800000 + 0x53] = {Pattern: 5, Red: 150, Green: 115, Blue: 70, Layer: "Water"};
//-------------------------------------------
// MapBasic constants

// TableInfo() defines

var TAB_INFO_NAME	= 1;
//--------------------------------
var FileHeader = new Array();
var MapSection, ImgSection;
var MapParams = new Array();
var ImgParams = new Array();
var LevelGrid = new Array();
var BlockIdFromatIsHex, BaseBlockID;
//--------------------------------
var fso = new ActiveXObject("Scripting.FileSystemObject");
var ForReading = 1, ForWriting = 2, ForAppending = 8;
var TristateTrue = -1, TristateFalse = 0, TristateUseDefault = -2;
//-------------------------------------------
function LTrim(Str) {
	var Chr;
	while (Chr = Str.substr(0, 1), Chr == " " || Chr == "\t" || Chr == "\r" || Chr == "\n")
		Str = Str.substr(1);
	return Str;
}
//-------------------------------------------
function RTrim(Str) {
	var Chr;
	while (Chr = Str.substr(Str.length - 1, 1), Chr == " " || Chr == "\t" || Chr == "\r" || Chr == "\n")
		Str = Str.substr(0, Str.length - 1);
	return Str;
}
//-------------------------------------------
function Trim(Str) {
	return LTrim(RTrim(Str));
}
//-------------------------------------------
function FillLeft(Str, Len, Fill) {
	while (String(Str).length < Len)
		Str = (String(Fill) != "undefined" ? Fill : " ") + Str;
	return Str;
}
//-------------------------------------------
function StatusMessage(NewStatus) {
	var Padding, CharNum;
	
	if (!CommandLineMode())
		return;
		
	for (Padding = "", CharNum = 0; CharNum < CurrentStatus.length - NewStatus.length; CharNum++, Padding += " ");

	WScript.StdOut.Write("\r" + NewStatus + Padding);
	CurrentStatus = NewStatus;
}
//-------------------------------------------
function InfoMessage(Message) {
	var Padding, CharNum;
	
	if (!CommandLineMode())
		return;
		
	for (Padding = "", CharNum = 0; CharNum < CurrentStatus.length - Message.length; CharNum++, Padding += " ");

	WScript.StdOut.Write("\r" + Message + Padding + "\n");
	CurrentStatus = "";
}
//-------------------------------------------
function WarningMessage(Message) {
	var Padding, CharNum;
	
	if (!CommandLineMode())
		return;
		
	for (Padding = "", CharNum = 0; CharNum < CurrentStatus.length - Message.length; CharNum++, Padding += " ");

	WScript.StdErr.Write("\r" + Message + Padding + "\n");
	CurrentStatus = "";
}
//-------------------------------------------
function ErrorMessage(Message) {
	var Padding, CharNum;
	
	if (!CommandLineMode()) {
		WScript.Echo(Message);
	} else {
		for (Padding = "", CharNum = 0; CharNum < CurrentStatus.length - Message.length; CharNum++, Padding += " ");

		WScript.StdErr.Write("\r" + Message + Padding + "\n");
		CurrentStatus = "";
	}
}
//-------------------------------------------
function ArrayIndexOf(Array, Value) {
	var Index;
	
	for (Index in Array)
		if (Array[Index] == Value)
			return Index;

	return -1;
}
//-------------------------------------------
function PointWithinLink(Point, Point1, Point2) {

	if (Point1.Latitude == Point2.Latitude)
		return Point.Latitude == Point1.Latitude
		&& (Point.Longitude >= Point1.Longitude && Point.Longitude <= Point2.Longitude
		|| Point.Longitude <= Point1.Longitude && Point.Longitude >= Point2.Longitude);
	else
		return (Point.Latitude - Point2.Latitude) * (Point1.Longitude - Point2.Longitude)
		/ (Point1.Latitude - Point2.Latitude) == Point.Longitude - Point2.Longitude;
}
//-------------------------------------------
function PointWithinPolygon(Point, Polygon) {
	// Tests point for being entirely within polygon
	// Returns 1 if point is entirely within polygon, 0 if it is on its border and -1 if it is outside polygon
	var Result, LastTouchingLinkSide, FirstNodeNum, FirstNodePassed, NodeNum, PrevNode, Node, NextNodeNum;
	var Longitude, Latitude0, Longitude0, Latitude1, Longitude1, Latitude2, Longitude2;

	if (Point.Latitude < Polygon.MinLatitude
	|| Point.Latitude > Polygon.MaxLatitude
	|| Point.Longitude < Polygon.MinLongitude
	|| Point.Longitude > Polygon.MaxLongitude)
		return -1;

	Result = false;
	LastTouchingLinkSide = 0;
	FirstNodeNum = 0;
	FirstNodePassed = false;
	PrevNode = Polygon.Nodes[0];
	for (NodeNum = 1; NodeNum != FirstNodeNum + 1 || !FirstNodePassed; NodeNum = NodeNum == Polygon.Nodes.length - 1 ? 0 : NodeNum + 1, PrevNode = Node) {
		Node = Polygon.Nodes[NodeNum];
		if (PrevNode.Latitude < Point.Latitude && Node.Latitude > Point.Latitude
		|| PrevNode.Latitude > Point.Latitude && Node.Latitude < Point.Latitude) {
			// Link crosses point's latitude
			Longitude = PrevNode.Longitude
			+ (Node.Longitude - PrevNode.Longitude) * (Point.Latitude - PrevNode.Latitude) / (Node.Latitude - PrevNode.Latitude);
			if (Longitude == Point.Longitude)
				// Link crosses the point
				return 0;
			else if (Longitude < Point.Longitude)
				// Link passes under the point
				Result = !Result;
			FirstNodePassed = true;
		} else if (PrevNode.Latitude == Point.Latitude && Node.Latitude == Point.Latitude) {
			// Link is entirely within point's latitude
			if (PrevNode.Longitude <= Point.Longitude && Node.Longitude >= Point.Longitude
			|| PrevNode.Longitude >= Point.Longitude && Node.Longitude <= Point.Longitude)
				// Link crosses the point
				return 0;
			if (FirstNodeNum == NodeNum - 1 && Node.Longitude < Point.Longitude)
				// There was no any link that crosses point's latitude or finishes at it yet
				FirstNodeNum++;
		} else if (PrevNode.Latitude != Point.Latitude && Node.Latitude == Point.Latitude) {
			// Link finishes at point's latitude
			if (Node.Longitude == Point.Longitude)
				// Link crosses the point
				return 0;
			else if (Node.Longitude < Point.Longitude)
				// Remember last touching link side
				LastTouchingLinkSide = PrevNode.Latitude < Point.Latitude ? -1 : 1;
			FirstNodePassed = true;
		} else if (PrevNode.Latitude == Point.Latitude && Node.Latitude != Point.Latitude) {
			// Link starts at point's latitude
			if (PrevNode.Longitude == Point.Longitude)
				// Link crosses the point
				return 0;
			else if (PrevNode.Longitude < Point.Longitude)
				if (LastTouchingLinkSide == 0)
					// There was no touching link yet. We should loop through the polygon 'till this node
					FirstNodeNum = NodeNum;
				else if (LastTouchingLinkSide == -1 && Node.Latitude > Point.Latitude
				|| LastTouchingLinkSide == 1 && Node.Latitude < Point.Latitude)
					// This liks with previous touching link together cross point's latitude
					Result = !Result;
		} else
			// Link does not cross point's latitude
			FirstNodePassed = true;
	}
	return Result ? 1 : -1;
}
//-------------------------------------------
function PointWithinRegion(Point, Region) {
	// Tests point for being within region
	// Returns 1 if point is entirely within region, 0 if it is on its border and -1 if it is outside polygon
	var IsWithin, PolygonID;

	IsWithin = -1;
	for (PolygonID in Region) {
		switch (PointWithinPolygon(Point, Region[PolygonID])) {
		case 0:
			return 0;
		case 1:
			IsWithin = -IsWithin;
			break;
		}
	}
	
	return IsWithin;
}
//-------------------------------------------
function GetAnyInternalPoint(Polygon) {
	// Returns any internal point of polygon
	var PrevNode, Node, NextNode, NodeNum, Point, DistanceReduced;
	
	if (Polygon.Area > 0)
		// Loop through all nodes as vertexes of angles
		for (NodeNum = 0,
		PrevNode = Polygon.Nodes[Polygon.Nodes.length - 2],
		Node = Polygon.Nodes[Polygon.Nodes.length - 1],
		NextNode = Polygon.Nodes[0];
		NodeNum < Polygon.Nodes.length;
		NodeNum++, PrevNode = Node, Node = NextNode, NextNode = Polygon.Nodes[NodeNum]) {
		
			// Check node for being fake node
			if (PrevNode.Latitude == Node.Latitude && PrevNode.Longitude == Node.Longitude
			|| NextNode.Latitude == Node.Latitude && NextNode.Longitude == Node.Longitude
			|| PointWithinLink(Node, PrevNode, NextNode))
				continue;
		
			// Find internal point for current angle
			Point = new Object();
			for (Point.Latitude = (PrevNode.Latitude + NextNode.Latitude) / 2,
			Point.Longitude = (PrevNode.Longitude + NextNode.Longitude) / 2,
			DistanceReduced = true;
			Point.Latitude != Node.Latitude || Point.Longitude != Node.Longitude;
			Point.Latitude = DistanceReduced ? 2 * Node.Latitude - Point.Latitude : (Point.Latitude + Node.Latitude) / 2,
			Point.Longitude = DistanceReduced ? 2 * Node.Longitude - Point.Longitude : (Point.Longitude + Node.Longitude) / 2,
			DistanceReduced = !DistanceReduced)
			
				if (PointWithinPolygon(Point, Polygon) == 1)
					return Point;
		}
}
//-------------------------------------------
function PolygonWithinPolygon(InnerPolygon, OuterPolygon) {
	// Test first polygon for being entirely within second polygon
	// Assumed that either one polygon is entirely within other polygon or polygons intersection is not a polygon
	// Returns -1 if InnerPolygon is not entirely within OuterPolygon
	// , 1 if InnerPolygon is entirely within OuterPolygon
	// or 0 if polygons are equal
	var NodeID, PolygonsAreEqual;
	var PrevInnerNode, InnerNode, NextInnerNode, OuterNodeNum, OuterNode, PrevOuterNode;
	var InternalPoint;

	if (InnerPolygon.MinLatitude < OuterPolygon.MinLatitude
	|| InnerPolygon.MinLongitude < OuterPolygon.MinLongitude
	|| InnerPolygon.MaxLatitude > OuterPolygon.MaxLatitude
	|| InnerPolygon.MaxLongitude > OuterPolygon.MaxLongitude
	|| InnerPolygon.Area > OuterPolygon.Area)
		return -1;
		
	for (NodeID in InnerPolygon.Nodes)
		switch (PointWithinPolygon(InnerPolygon.Nodes[NodeID], OuterPolygon)) {
		case -1:
			return -1;
		case 1:
			return 1;
		}
	
	PolygonsAreEqual = true;
	for (NodeID in OuterPolygon.Nodes)
		switch (PointWithinPolygon(OuterPolygon.Nodes[NodeID], InnerPolygon)) {
		case -1:
			PolygonsAreEqual = false;
			break;
		case 1:
			return -1;
		}
	
	if (PolygonsAreEqual)
		return 0;
		
	// Now all nodes of inner polygon are on the border of outer polygon
	// We need to find whether inner polygon is within, or not within outer polygon
	
	if (InnerPolygon.Area == 0)
		return 1;

	InternalPoint = GetAnyInternalPoint(InnerPolygon);
	if (String(InternalPoint) == "undefined")
		return 1;

	return PointWithinPolygon(InternalPoint, OuterPolygon);
}
//-------------------------------------------
function ExplodeRegion(Region, Regions) {
	// Divides region into an array of non-intersecting regions
	var ParentPolygonNum, PolygonIsParent, PolygonNum;
	var PolygonWasUsed, UsedPolygonsNum, UsedPolygonsNums, NewRegion, ChildPolygonNum, ChildPolygonNumNum, ParentPolygonNumNum;

	PolygonWasUsed = new Array();
	UsedPolygonsNum = 0;
	while (UsedPolygonsNum < Region.length)
		for (ParentPolygonNum = 0; ParentPolygonNum < Region.length; ParentPolygonNum++) {
			if (PolygonWasUsed[ParentPolygonNum]) continue;
			// Test current polygon for not being within any other polygon
			PolygonIsParent = true;
			for (PolygonNum = 0; PolygonNum < Region.length; PolygonNum++) {
				if (PolygonWasUsed[ParentPolygonNum]) continue;
				if (PolygonNum != ParentPolygonNum)
					if (PolygonWithinPolygon(Region[ParentPolygonNum], Region[PolygonNum]) == 1) {
						PolygonIsParent = false;
						break;
					}
			}
			if (PolygonIsParent) {
				// This polygon is one of parents
				UsedPolygonsNums = new Array();
				NewRegion = new Array();
				NewRegion.push(Region[ParentPolygonNum]);

				// Find this polygon's children
				for (ChildPolygonNum = 0; ChildPolygonNum < Region.length; ChildPolygonNum++) {
					if (PolygonWasUsed[ChildPolygonNum]) continue;
					if (ChildPolygonNum != ParentPolygonNum)
						if (PolygonWithinPolygon(Region[ChildPolygonNum], Region[ParentPolygonNum]) == 1)
							UsedPolygonsNums.push(ChildPolygonNum);
				}

				// Delete numbers of children that are within some other children
				for (ChildPolygonNumNum = UsedPolygonsNums.length - 1; ChildPolygonNumNum >= 0; ChildPolygonNumNum--) {
					for (ParentPolygonNumNum = 0; ParentPolygonNumNum < UsedPolygonsNums.length; ParentPolygonNumNum++)
						if (ChildPolygonNumNum != ParentPolygonNumNum
						&& PolygonWithinPolygon(Region[UsedPolygonsNums[ChildPolygonNumNum]], Region[UsedPolygonsNums[ParentPolygonNumNum]]) >= 0) {
							UsedPolygonsNums.splice(ChildPolygonNumNum, 1);
							break;
						}
				}

				// Add children polygons to region
				for (ChildPolygonNumNum = 0; ChildPolygonNumNum < UsedPolygonsNums.length; ChildPolygonNumNum++)
					NewRegion.push(Region[UsedPolygonsNums[ChildPolygonNumNum]]);

				UsedPolygonsNums.push(ParentPolygonNum);
				Regions.push(NewRegion);
				// When we got complete region, we need to remove its polygons from source list (region)
				// to make "lakes on islands" be able to become parent polygons
				while (UsedPolygonsNums.length > 0) {
					PolygonWasUsed[UsedPolygonsNums.pop()] = true;
					UsedPolygonsNum++;
				}
				break;
			}
		}

}
//-------------------------------------------
function ValidateSection(Section) {
	var Nodes, NodeNum;

	Nodes = Section.Nodes;
	// Delete fake nodes between first and last nodes
	for (NodeNum = 1; NodeNum < Nodes.length; NodeNum++) {
		if (Nodes[NodeNum - 1].Latitude == Nodes[NodeNum].Latitude
		&& Nodes[NodeNum - 1].Longitude == Nodes[NodeNum].Longitude) {
			Nodes.splice(NodeNum, 1);
			NodeNum--;
		} else if(NodeNum > 1
		&& PointWithinLink(Nodes[NodeNum - 1], Nodes[NodeNum - 2], Nodes[NodeNum])) {
			Nodes.splice(NodeNum - 1, 1);
			NodeNum -= 2;
		}
	}
	SetSectionProperties(Section);
}
//-------------------------------------------
function ValidateRegion(Region, SourceObjectLineNum, LevelID) {
	// Validates region
	// Currently only deletes duplicated polygons
	var ThereWereFakeNodes, PolygonNum, Polygon, Nodes, NodeNum, PrevNode, Node, NextNode;
	var PolygonsToDelete, OriginalPolygonNum, Duplicates, DuplicatePolygonNum, PolygonNumID;
	var Message, Padding, CharNum;
	
	// Validate polygons (delete fake nodes, delete fake polygons)
	for (PolygonNum = 0; PolygonNum < Region.length; PolygonNum++) {
		StatusMessage("Processing line " + SourceObjectLineNum + ", region at level " + LevelID + ": Validating polygons (" + (PolygonNum + 1 ) + "/" + Region.length + ")...");
		Polygon = Region[PolygonNum];
		ValidatePolygon(Polygon);
		if (Polygon.Nodes.length < 3) {
			if (CommandLineMode()) {
				WarningMessage("Warning: Line " + SourceObjectLineNum + ", region at level " + LevelID
				+ ": Polygon " + Polygon.SourcePolygons[0] + " is fake");
			}
			Region.splice(PolygonNum, 1);
			PolygonNum--;
		}
	}
	
	// Delete duplicated polygons
	PolygonsToDelete = new Array();
	for (OriginalPolygonNum = 0; OriginalPolygonNum < Region.length - 1; OriginalPolygonNum++) {
		StatusMessage("Processing line " + SourceObjectLineNum + ", region at level " + LevelID + ": Checking for duplicated polygons (" + (OriginalPolygonNum + 1 ) + "/" + Region.length + ")...");
		if (ArrayIndexOf(PolygonsToDelete, OriginalPolygonNum) != -1)
			continue; // Polygon is already a duplicate of some earlier polygon
		Duplicates = new Array();
		for (DuplicatePolygonNum = OriginalPolygonNum + 1; DuplicatePolygonNum < Region.length; DuplicatePolygonNum++)
			if (Region[DuplicatePolygonNum].MinLatitude == Region[OriginalPolygonNum].MinLatitude
			&& Region[DuplicatePolygonNum].MinLongitude == Region[OriginalPolygonNum].MinLongitude
			&& Region[DuplicatePolygonNum].MaxLatitude == Region[OriginalPolygonNum].MaxLatitude
			&& Region[DuplicatePolygonNum].MaxLongitude == Region[OriginalPolygonNum].MaxLongitude
			&& PolygonWithinPolygon(Region[DuplicatePolygonNum], Region[OriginalPolygonNum]) == 0)
				Duplicates.push(DuplicatePolygonNum);
		if (Duplicates.length > 0) {
			if (CommandLineMode()) {
				Message = "Warning: Line " + SourceObjectLineNum + ", region at level " + LevelID
				+ ": Polygon " + Region[OriginalPolygonNum].SourcePolygons[0] + " is duplicated by polygon"
				+ (Duplicates.length == 1 ? "" : "s ");
				for (DuplicatePolygonNum = 0; DuplicatePolygonNum < Duplicates.length; DuplicatePolygonNum++)
					Message += (DuplicatePolygonNum == 0 ? "" : ", ") + Region[Duplicates[DuplicatePolygonNum]].SourcePolygons[0];
				Message += ".";
				WarningMessage(Message);
			}
			if (Duplicates.length % 2 == 1)
				PolygonsToDelete.push(OriginalPolygonNum);
			for (PolygonNumID in Duplicates)
				PolygonsToDelete.push(Duplicates[PolygonNumID]);
		}
	}
	for (PolygonNumID = PolygonsToDelete.length - 1; PolygonNumID >= 0; PolygonNumID--)
		Region.splice(PolygonsToDelete[PolygonNumID], 1);
}
//-------------------------------------------
function ValidatePolyline(Polyline, SourceObjectLineNum, LevelID) {
	var LineNum, Line, Message, Padding;

	// Validate sections (delete fake nodes, delete fake sections)
	for (LineNum = 0; LineNum < Polyline.length; LineNum++) {
		StatusMessage("Processing line " + SourceObjectLineNum + ", polyline at level " + LevelID + ": Validating lines (" + (LineNum + 1 ) + "/" + Polyline.length + ")...");
		Line = Polyline[LineNum];
		ValidateSection(Line);
		if (Line.Nodes.length < 2) {
			if (CommandLineMode()) {
				WarningMessage("Warning: Line " + SourceObjectLineNum + ", polyline at level " + LevelID
				+ ": Line " + Line.SourceSections[0] + " is fake");
			}
			Polyline.splice(LineNum, 1);
			LineNum--;
		}
	}
}
//-------------------------------------------
function SetPolygonProperties(Polygon) {
	// Sets polygon Area, Direction, MinLatitude, MinLongitude, MaxLatitude, MaxLongitude and Centroid
	var NodeNum, Node, PrevNode, TrapeziumArea, LatOffset, Lat, Lon, Ratio;
	
	// Calculate bounds
	Polygon.MinLatitude = Polygon.Nodes[0].Latitude;
	Polygon.MinLongitude = Polygon.Nodes[0].Longitude;
	Polygon.MaxLatitude = Polygon.Nodes[0].Latitude;
	Polygon.MaxLongitude = Polygon.Nodes[0].Longitude;
	for (NodeNum = 1; NodeNum < Polygon.Nodes.length; NodeNum++) {
		Polygon.MinLatitude = Math.min(Polygon.MinLatitude, Polygon.Nodes[NodeNum].Latitude);
		Polygon.MinLongitude = Math.min(Polygon.MinLongitude, Polygon.Nodes[NodeNum].Longitude);
		Polygon.MaxLatitude = Math.max(Polygon.MaxLatitude, Polygon.Nodes[NodeNum].Latitude);
		Polygon.MaxLongitude = Math.max(Polygon.MaxLongitude, Polygon.Nodes[NodeNum].Longitude);
	}
	
	Polygon.Area = 0;
	if (Polygon.Nodes.length > 0) {
		Polygon.Centroid = new Object;
		Node = Polygon.Nodes[Polygon.Nodes.length - 1];
		Polygon.Centroid.Latitude = Node.Latitude;
		Polygon.Centroid.Longitude = Node.Longitude;
		for (NodeNum = 0; NodeNum < Polygon.Nodes.length; NodeNum++) {
			PrevNode = Node;
			Node = Polygon.Nodes[NodeNum];

			// Calculate current trapezium area
			TrapeziumArea = (Node.Latitude - PrevNode.Latitude) * (Node.Longitude + PrevNode.Longitude - 2 * Polygon.MinLongitude);
			if (TrapeziumArea != 0) {
				
				// Calculate current trapezium centroid position
				LatOffset = (2 * Node.Longitude + PrevNode.Longitude - 3 * Polygon.MinLongitude) * (Node.Latitude - PrevNode.Latitude)
				/ (3 * (PrevNode.Longitude + Node.Longitude - 2 * Polygon.MinLongitude));
				Lat = PrevNode.Latitude + LatOffset;
				Lon = (PrevNode.Longitude - Polygon.MinLongitude + (Node.Longitude - PrevNode.Longitude)
				* LatOffset / (Node.Latitude - PrevNode.Latitude)) / 2 + Polygon.MinLongitude;
				
				if (Polygon.Area == 0) {
					// Polygon is fake. Get trapezium centroid
					Polygon.Centroid.Latitude = Lat;
					Polygon.Centroid.Longitude = Lon;
				} else if (TrapeziumArea == -Polygon.Area) {
					// Polygon is getting fake. Get current node as centroid
					Polygon.Centroid.Latitude = Node.Latitude;
					Polygon.Centroid.Longitude = Node.Longitude;
				} else {
					// Find centroid of polygon and current trapezium
					Ratio = TrapeziumArea / (Polygon.Area + TrapeziumArea);
					Polygon.Centroid.Latitude = Polygon.Centroid.Latitude + (Lat - Polygon.Centroid.Latitude) * Ratio;
					Polygon.Centroid.Longitude = Polygon.Centroid.Longitude + (Lon - Polygon.Centroid.Longitude) * Ratio;
				}

				// Update area
				Polygon.Area += TrapeziumArea;
			}
		}
	}
		
	Polygon.Direction = Polygon.Area > 0 ? 1 : Polygon.Area < 0 ? -1 : 0;
	Polygon.Area = Polygon.Area * Polygon.Direction / 2;
	
}
//-------------------------------------------
function SetSectionProperties(Section) {
	// Sets section MinLatitude, MinLongitude, MaxLatitude, MaxLongitude
	var NodeNum;
	
	for (NodeNum = 0; NodeNum < Section.Nodes.length; NodeNum++)
		if (NodeNum == 0) {
			Section.MinLatitude = Section.Nodes[NodeNum].Latitude;
			Section.MinLongitude = Section.Nodes[NodeNum].Longitude;
			Section.MaxLatitude = Section.Nodes[NodeNum].Latitude;
			Section.MaxLongitude = Section.Nodes[NodeNum].Longitude;
		} else {
			Section.MinLatitude = Math.min(Section.MinLatitude, Section.Nodes[NodeNum].Latitude);
			Section.MinLongitude = Math.min(Section.MinLongitude, Section.Nodes[NodeNum].Longitude);
			Section.MaxLatitude = Math.max(Section.MaxLatitude, Section.Nodes[NodeNum].Latitude);
			Section.MaxLongitude = Math.max(Section.MaxLongitude, Section.Nodes[NodeNum].Longitude);
		}
}
//-------------------------------------------
function ValidatePolygon(Polygon) {
	var Nodes, NodeNum;

	Nodes = Polygon.Nodes;
	// Delete fake nodes between first and last nodes
	for (NodeNum = 1; NodeNum < Nodes.length; NodeNum++) {
		if (Nodes[NodeNum - 1].Latitude == Nodes[NodeNum].Latitude
		&& Nodes[NodeNum - 1].Longitude == Nodes[NodeNum].Longitude) {
			Nodes.splice(NodeNum, 1);
			NodeNum--;
		} else if(NodeNum > 1
		&& ((Nodes[NodeNum - 2].Latitude == Nodes[NodeNum - 1].Latitude
		&& Nodes[NodeNum].Latitude == Nodes[NodeNum - 1].Latitude)
		|| (Nodes[NodeNum - 2].Latitude != Nodes[NodeNum - 1].Latitude
		&& Nodes[NodeNum].Longitude == Nodes[NodeNum - 1].Longitude
		+ (Nodes[NodeNum - 2].Longitude - Nodes[NodeNum - 1].Longitude)
		/ (Nodes[NodeNum - 2].Latitude - Nodes[NodeNum - 1].Latitude)
		* (Nodes[NodeNum].Latitude - Nodes[NodeNum - 1].Latitude)))) {
			Nodes.splice(NodeNum - 1, 1);
			NodeNum -= 2;
		}
	}
	// Delete fake nodes at begin and at the end of polygon
	while (Nodes.length > 1) {
		// Check whether last node is equal to first one
		if (Nodes[Nodes.length - 1].Latitude == Nodes[0].Latitude
		&& Nodes[Nodes.length - 1].Longitude == Nodes[0].Longitude) {
			Nodes.pop();
			continue;
		}
		// Check whether last node is fake
		if (Nodes.length > 2
		&& ((Nodes[Nodes.length - 2].Latitude == Nodes[Nodes.length - 1].Latitude
		&& Nodes[0].Latitude == Nodes[Nodes.length - 1].Latitude)
		|| (Nodes[Nodes.length - 2].Latitude != Nodes[Nodes.length - 1].Latitude
		&& Nodes[0].Longitude == Nodes[Nodes.length - 1].Longitude
		+ (Nodes[Nodes.length - 2].Longitude - Nodes[Nodes.length - 1].Longitude)
		/ (Nodes[Nodes.length - 2].Latitude - Nodes[Nodes.length - 1].Latitude)
		* (Nodes[0].Latitude - Nodes[Nodes.length - 1].Latitude)))) {
			Nodes.pop();
			continue;
		}
		// Check whether first node is fake
		if (Nodes.length > 2
		&& ((Nodes[Nodes.length - 1].Latitude == Nodes[0].Latitude
		&& Nodes[1].Latitude == Nodes[0].Latitude)
		|| (Nodes[Nodes.length - 1].Latitude != Nodes[0].Latitude
		&& Nodes[1].Longitude == Nodes[0].Longitude
		+ (Nodes[Nodes.length - 1].Longitude - Nodes[0].Longitude)
		/ (Nodes[Nodes.length - 1].Latitude - Nodes[0].Latitude)
		* (Nodes[1].Latitude - Nodes[0].Latitude)))) {
			Nodes.shift();
			continue;
		}
		break;
	}
	SetPolygonProperties(Polygon);
	if (Polygon.Direction < 0) {
		Polygon.Nodes.reverse();
		Polygon.Direction = -Polygon.Direction;
	}
}
//-------------------------------------------
function ImportNode(NodeSource) {
	// Imports and returns node from text string
	var Node, SeparatorIndex, Latitude, Longitude;

	NodeSource = LTrim(NodeSource);
	if (NodeSource.charAt(0) == "(") {
		NodeSource = LTrim(NodeSource.substring(1, NodeSource.length)); // remove leading "("

		// Get latitude
		SeparatorIndex = NodeSource.indexOf(",");
		Latitude = parseFloat(RTrim(NodeSource.substring(0, SeparatorIndex)));
		NodeSource = LTrim(NodeSource.substring(SeparatorIndex + 1, NodeSource.length)); // remove latitude value and comma

		// Get longitude
		SeparatorIndex = NodeSource.indexOf(")");
		Longitude = parseFloat(RTrim(NodeSource.substring(0, SeparatorIndex)));
		
		Node = new Object();
		Node.Latitude = Latitude;
		Node.Longitude = Longitude;

		NodesProcessed++;
	}
	
	return Node;
}
//-------------------------------------------
function ImportPolygon(PolygonSource) {
	// Imports and returns polygon from text string
	var Polygon, Nodes, SeparatorIndex, Latitude, Longitude, Node;

	PolygonSource = LTrim(PolygonSource);
	Polygon = new Object();
	Nodes = new Array();
	while (PolygonSource.charAt(0) == "(") {
		PolygonSource = LTrim(PolygonSource.substring(1, PolygonSource.length)); // remove leading "("

		// Get latitude
		SeparatorIndex = PolygonSource.indexOf(",");
		Latitude = parseFloat(RTrim(PolygonSource.substring(0, SeparatorIndex)));
		PolygonSource = LTrim(PolygonSource.substring(SeparatorIndex + 1, PolygonSource.length)); // remove latitude value and comma

		// Get longitude
		SeparatorIndex = PolygonSource.indexOf(")");
		Longitude = parseFloat(RTrim(PolygonSource.substring(0, SeparatorIndex)));
		PolygonSource = LTrim(PolygonSource.substring(SeparatorIndex + 1, PolygonSource.length)); // remove longitude value and closing bracket

		SeparatorIndex = PolygonSource.indexOf(",");
		PolygonSource = LTrim(PolygonSource.substring(SeparatorIndex + 1, PolygonSource.length)); // remove comma
		
		Node = new Object();
		Node.Latitude = Latitude;
		Node.Longitude = Longitude;
		Nodes.push(Node);
	}
	Polygon.Nodes = Nodes;
	
	return Polygon;
}
//-------------------------------------------
function ImportLine(SectionSource) {
	return ImportPolygon(SectionSource);
}
//-------------------------------------------
function PolylineCentroid(Polyline) {
	// Connect all sections into one line and find the middle point of that line
	var SectionUsed, SectionsUsed, Nodes, CurNodes, ShortestDistance, AddToEnd, Reverse, ClosestNodes, ClosestSectionNum, Distance;
	var TotalLength, NodeNum, Length, LinkLength, Centroid;
	
	SectionUsed = new Array(Polyline.length);
	SectionsUsed = 0;
	Nodes = Polyline[0].Nodes.slice(0);
	SectionUsed[0] = true;
	SectionsUsed++;
	while (SectionsUsed < Polyline.length) {
		// Find next unused section one end of which is closest to end of resulting section
		ShortestDistance = undefined;
		for (SectionNum = 1; SectionNum < Polyline.length; SectionNum++)
			if (!SectionUsed[SectionNum]) {
				CurNodes = Polyline[SectionNum].Nodes;
				// Start to start
				Distance = Math.pow(Nodes[0].Latitude - CurNodes[0].Latitude, 2)
				+ Math.pow(Nodes[0].Longitude - CurNodes[0].Longitude, 2);
				if (ShortestDistance == undefined || Distance < ShortestDistance) {
					ShortestDistance = Distance;
					AddToEnd = false;
					Reverse = true;
					ClosestNodes = CurNodes;
					ClosestSectionNum = SectionNum;
				}
				// Start to end
				Distance = Math.pow(Nodes[0].Latitude - CurNodes[CurNodes.length - 1].Latitude, 2)
				+ Math.pow(Nodes[0].Longitude - CurNodes[CurNodes.length - 1].Longitude, 2);
				if (ShortestDistance == undefined || Distance < ShortestDistance) {
					ShortestDistance = Distance;
					AddToEnd = false;
					Reverse = false;
					ClosestNodes = CurNodes;
					ClosestSectionNum = SectionNum;
				}
				// End to start
				Distance = Math.pow(Nodes[Nodes.length - 1].Latitude - CurNodes[0].Latitude, 2)
				+ Math.pow(Nodes[Nodes.length - 1].Longitude - CurNodes[0].Longitude, 2);
				if (ShortestDistance == undefined || Distance < ShortestDistance) {
					ShortestDistance = Distance;
					AddToEnd = true;
					Reverse = false;
					ClosestNodes = CurNodes;
					ClosestSectionNum = SectionNum;
				}
				// End to end
				Distance = Math.pow(Nodes[Nodes.length - 1].Latitude - CurNodes[CurNodes.length - 1].Latitude, 2)
				+ Math.pow(Nodes[Nodes.length - 1].Longitude - CurNodes[CurNodes.length - 1].Longitude, 2);
				if (ShortestDistance == undefined || Distance < ShortestDistance) {
					ShortestDistance = Distance;
					AddToEnd = true;
					Reverse = true;
					ClosestNodes = CurNodes;
					ClosestSectionNum = SectionNum;
				}
			}
		if (AddToEnd)
			Nodes = Nodes.concat(Reverse ? ClosestNodes.reverse() : ClosestNodes);
		else
			Nodes = (Reverse ? ClosestNodes.reverse() : ClosestNodes).concat(Nodes);

		SectionUsed[ClosestSectionNum] = true;
		SectionsUsed++;
	}
	
	TotalLength = 0;
	for (NodeNum = 1; NodeNum < Nodes.length; NodeNum++)
		TotalLength += Math.sqrt(Math.pow(Nodes[NodeNum].Latitude - Nodes[NodeNum - 1].Latitude, 2)
		+ Math.pow(Nodes[NodeNum].Longitude - Nodes[NodeNum - 1].Longitude, 2));
	TotalLength /= 2;
		
	Length = 0;
	for (NodeNum = 1; NodeNum < Nodes.length; NodeNum++) {
		LinkLength = Math.sqrt(Math.pow(Nodes[NodeNum].Latitude - Nodes[NodeNum - 1].Latitude, 2)
		+ Math.pow(Nodes[NodeNum].Longitude - Nodes[NodeNum - 1].Longitude, 2));
		if (Length <= TotalLength && (Length + LinkLength) >= TotalLength) {
			Centroid = new Object();
			Centroid.Latitude = Nodes[NodeNum - 1].Latitude
			+ (Nodes[NodeNum].Latitude - Nodes[NodeNum - 1].Latitude) * (TotalLength - Length) / LinkLength;
			Centroid.Longitude = Nodes[NodeNum - 1].Longitude
			+ (Nodes[NodeNum].Longitude - Nodes[NodeNum - 1].Longitude) * (TotalLength - Length) / LinkLength;

			return Centroid;
		}
		Length += LinkLength;
	}
}
//-------------------------------------------
function RegionCentroid(Region) {
	var PolygonID, Regions, RegionID, PolygonCentroid, PolygonArea, Centroid, Area, Ratio;
	var PolygonID, NodeID, Node, Distance, ShortestDistance, ClosestNode;

	for (PolygonID in Region)
		SetPolygonProperties(Region[PolygonID]);
		
	// Explode region to a set of non-intersecting regions to be able to see which polygons are outer, and which are inner.
	Regions = new Array();
	ExplodeRegion(Region, Regions);
	
	for (RegionID in Regions)
		for (PolygonNum = 0; PolygonNum < Regions[RegionID].length; PolygonNum++) {
			PolygonCentroid = Regions[RegionID][PolygonNum].Centroid;
			PolygonArea = PolygonNum == 0 ? Regions[RegionID][PolygonNum].Area : -Regions[RegionID][PolygonNum].Area;
			if (Centroid == undefined) {
				Centroid = new Object();
				Centroid.Latitude = PolygonCentroid.Latitude;
				Centroid.Longitude = PolygonCentroid.Longitude;
				Area = PolygonArea;
			} else {
				Ratio = PolygonArea / (Area + PolygonArea);
				Centroid.Latitude = Centroid.Latitude + (PolygonCentroid.Latitude - Centroid.Latitude) * Ratio;
				Centroid.Longitude = Centroid.Longitude + (PolygonCentroid.Longitude - Centroid.Longitude) * Ratio;
			}
		}
		
	// If centroid is not entirely within region, find closest point in region
	if (PointWithinRegion(Centroid, Region) < 0) {
		for (PolygonID in Region)
			for (NodeID in Region[PolygonID].Nodes) {
				Node = Region[PolygonID].Nodes[NodeID];
				Distance = Math.pow(Node.Latitude - Centroid.Latitude, 2) + Math.pow(Node.Longitude - Centroid.Longitude, 2);
				if (ShortestDistance == undefined || Distance < ShortestDistance) {
					ShortestDistance = Distance;
					ClosestNode = Node;
				}
			}
		Centroid.Latitude = ClosestNode.Latitude;
		Centroid.Longitude = ClosestNode.Longitude;
	}
	
	return Centroid;
}
//-------------------------------------------
function ProcessPoint(MapInfo, Node, Class, Type, LevelID, Label, SourceObjectLineNum, DestinationFolderName) {
	var TableName, CurTableName, MostAncientTableName, MostAncientTableAge;

	TableName = "Points" + LevelID;

	// Open destination table if it is not opened yet
	if (CreatedTables[TableName] == undefined || CreatedTables[TableName] == 0) {
		if (OpenedTablesCnt == MaxOpenedTablesCnt) {
			// Close one opened table that was used most ancient
			for (CurTableName in CreatedTables)
				if (CurTableName != TableName && CreatedTables[CurTableName] > 0)
					if (MostAncientTableAge == undefined || MostAncientTableAge > CreatedTables[CurTableName]) {
						MostAncientTableName = CurTableName;
						MostAncientTableAge = CreatedTables[CurTableName];
					}
			MapInfo.Do("Commit Table " + MostAncientTableName);
			MapInfo.Do("Close Table " + MostAncientTableName);
			CreatedTables[MostAncientTableName] = 0;
			OpenedTablesCnt--;
		}
		if (CreatedTables[TableName] == undefined) {
			MapInfo.Do("Create Table " + TableName + " (Class Char(2), Type Char(64), Label Char(128)) File \"" + fso.BuildPath(DestinationFolderName, TableName) + "\"");
			MapInfo.Do("Create Map For " + TableName + " CoordSys Earth Projection 1, 0");
			OpenedTablesCnt++;
		} else {
			MapInfo.Do("Open Table \"" + fso.BuildPath(DestinationFolderName, TableName) + "\"");
			OpenedTablesCnt++;
		}
	}
	
	// Write current object to destination table
	MapInfo.Do("Insert Into " + TableName + " (Obj, Class, Type, Label) Values (CreatePoint("
	+ Node.Longitude + ", " + Node.Latitude	+ "), \"" + Class + "\", \"" + Type + "\", \"" + Label.replace("\"", "''") + "\")");
	//MapInfo.Do("Commit Table " + TableName);
	CreatedTables[TableName] = SourceObjectLineNum;
}
//-------------------------------------------
function ProcessPolyline(MapInfo, Polyline, Class, Type, LevelID, Label, SourceObjectLineNum, DestinationFolderName) {
	var Style, TableName, CurTableName, MostAncientTableName, MostAncientTableAge;

	Style = Styles[0x400000 + eval(Type)];
	TableName = (Style != undefined ? Style.Layer : "Other") + LevelID;

	// Open destination table if it is not opened yet
	if (CreatedTables[TableName] == undefined || CreatedTables[TableName] == 0) {
		if (OpenedTablesCnt == MaxOpenedTablesCnt) {
			// Close one opened table that was used most ancient
			for (CurTableName in CreatedTables)
				if (CurTableName != TableName && CreatedTables[CurTableName] > 0)
					if (MostAncientTableAge == undefined || MostAncientTableAge > CreatedTables[CurTableName]) {
						MostAncientTableName = CurTableName;
						MostAncientTableAge = CreatedTables[CurTableName];
					}
			MapInfo.Do("Commit Table " + MostAncientTableName);
			MapInfo.Do("Close Table " + MostAncientTableName);
			CreatedTables[MostAncientTableName] = 0;
			OpenedTablesCnt--;
		}
		if (CreatedTables[TableName] == undefined) {
			MapInfo.Do("Create Table " + TableName + " (Class Char(2), Type Char(64), Label Char(128)) File \"" + fso.BuildPath(DestinationFolderName, TableName) + "\"");
			MapInfo.Do("Create Map For " + TableName + " CoordSys Earth Projection 1, 0");
			OpenedTablesCnt++;
		} else {
			MapInfo.Do("Open Table \"" + fso.BuildPath(DestinationFolderName, TableName) + "\"");
			OpenedTablesCnt++;
		}
	}
	
	// Write current object to destination table
	MapInfo.Do("Create PLine Into Variable pmf2mi_Obj 0"
	+ (Style != undefined ? " Pen MakePen(" + Style.Width + ", " + Style.Pattern + ", RGB(" + Style.Red + ", " + Style.Green + ", " + Style.Blue + "))" : ""));
	for (SectionID = 0; SectionID < Polyline.length; SectionID++)
		for (NodeID = 0; NodeID < Polyline[SectionID].Nodes.length; NodeID++)
			MapInfo.Do("Alter Object pmf2mi_Obj Node Add Position " + (SectionID + 1) + ", " + (NodeID + 1)
			+ " (" + Polyline[SectionID].Nodes[NodeID].Longitude + ", " + Polyline[SectionID].Nodes[NodeID].Latitude + ")");
	MapInfo.Do("Insert Into " + TableName + " (Obj, Class, Type, Label) Values (pmf2mi_Obj, \""
	+ Class + "\", \"" + Type + "\", \"" + Label.replace("\"", "''") + "\")");
	//MapInfo.Do("Commit Table " + TableName);
	CreatedTables[TableName] = SourceObjectLineNum;
}
//-------------------------------------------
function ProcessRegion(MapInfo, Polyline, Class, Type, LevelID, Label, SourceObjectLineNum, DestinationFolderName) {
	var Style, TableName, CurTableName, MostAncientTableName, MostAncientTableAge;

	Style = Styles[0x800000 + eval(Type)];
	TableName = (Style != undefined ? Style.Layer : "Other") + LevelID;

	// Open destination table if it is not opened yet
	if (CreatedTables[TableName] == undefined || CreatedTables[TableName] == 0) {
		if (OpenedTablesCnt == MaxOpenedTablesCnt) {
			// Close one opened table that was used most ancient
			for (CurTableName in CreatedTables)
				if (CurTableName != TableName && CreatedTables[CurTableName] > 0)
					if (MostAncientTableAge == undefined || MostAncientTableAge > CreatedTables[CurTableName]) {
						MostAncientTableName = CurTableName;
						MostAncientTableAge = CreatedTables[CurTableName];
					}
			MapInfo.Do("Commit Table " + MostAncientTableName);
			MapInfo.Do("Close Table " + MostAncientTableName);
			CreatedTables[MostAncientTableName] = 0;
			OpenedTablesCnt--;
		}
		if (CreatedTables[TableName] == undefined) {
			MapInfo.Do("Create Table " + TableName + " (Class Char(2), Type Char(64), Label Char(128)) File \"" + fso.BuildPath(DestinationFolderName, TableName) + "\"");
			MapInfo.Do("Create Map For " + TableName + " CoordSys Earth Projection 1, 0");
			OpenedTablesCnt++;
		} else {
			MapInfo.Do("Open Table \"" + fso.BuildPath(DestinationFolderName, TableName) + "\"");
			OpenedTablesCnt++;
		}
	}
	
	// Write current object to destination table
	MapInfo.Do("Create Region Into Variable pmf2mi_Obj 0"
	+ (Style != undefined ? " Pen MakePen(1, 1, RGB(0, 0, 0)) Brush MakeBrush(" + Style.Pattern + ", RGB(" + Style.Red + ", " + Style.Green + ", " + Style.Blue + "), RGB(255, 255, 255))" : ""));
	for (SectionID = 0; SectionID < Polyline.length; SectionID++)
		for (NodeID = 0; NodeID < Polyline[SectionID].Nodes.length; NodeID++)
			MapInfo.Do("Alter Object pmf2mi_Obj Node Add Position " + (SectionID + 1) + ", " + (NodeID + 1)
			+ " (" + Polyline[SectionID].Nodes[NodeID].Longitude + ", " + Polyline[SectionID].Nodes[NodeID].Latitude + ")");
	MapInfo.Do("Insert Into " + TableName + " (Obj, Class, Type, Label) Values (pmf2mi_Obj, \""
	+ Class + "\", \"" + Type + "\", \"" + Label.replace("\"", "''") + "\")");
	//MapInfo.Do("Commit Table " + TableName);
	CreatedTables[TableName] = SourceObjectLineNum;
}
//-------------------------------------------
function ProcessImgSection(MapInfo, SourceSection, SourceObjectLineNum) {
	var ElementNum, EquationSignIndex, ElementID, ElementValue, LevelID;

	for (ElementNum = 1; ElementNum < SourceSection.length - 1; ElementNum++) {
		EquationSignIndex = SourceSection[ElementNum].indexOf("=");
		if (EquationSignIndex != -1) {
			ElementID = Trim(SourceSection[ElementNum].substr(0, EquationSignIndex)).toLowerCase();
			ElementValue = LTrim(SourceSection[ElementNum].substring(EquationSignIndex + 1, SourceSection[ElementNum].length));
			ImgParams[ElementID] = ElementValue;
		}
	}
	if (ImgParams["datum"] != undefined && ImgParams["datum"].toUpperCase() != "W84")
		ErrorMessage("Error: Datums other that WGS 84 are not supported. Datum is treated as WGS 84.");
}
//-------------------------------------------
function ProcessPOISection(MapInfo, SourceSection, SourceObjectLineNum, DestinationFolderName) {
	var ElementNum, EquationSignIndex, ElementID, ElementValue, LevelID, MinLevelID, MaxLevelID, Node;
	var Latitude, Longitude, Type, Label, MoreLevels, NodeID;

	Label = "";
	Levels = new Array();
	for (ElementNum = 1; ElementNum < SourceSection.length - 1; ElementNum++) {
		//StatusMessage("Processing line " + SourceObjectLineNum + ": Importing block (" + (ElementNum + 1) + "/" + SourceSection.length + ")...");
		EquationSignIndex = SourceSection[ElementNum].indexOf("=");
		if (EquationSignIndex != -1) {
			ElementID = Trim(SourceSection[ElementNum].substr(0, EquationSignIndex));
			ElementValue = Trim(SourceSection[ElementNum].substring(EquationSignIndex + 1, SourceSection[ElementNum].length));
			if (ElementID.substr(0, 4).toUpperCase() == "DATA"
			|| ElementID.substr(0, 6).toUpperCase() == "ORIGIN") {
				LevelID = parseInt(ElementID.substring((ElementID.substr(0, 6).toUpperCase() == "ORIGIN" ? 6 : 4), ElementID.length));
				MinLevelID = MinLevelID == undefined ? LevelID : Math.min(MinLevelID, LevelID);
				MaxLevelID = MaxLevelID == undefined ? LevelID : Math.max(MaxLevelID, LevelID);
				Node = ImportNode(ElementValue);
				if (Levels[LevelID] == undefined)
					Levels[LevelID] = new Array();
				Levels[LevelID].push(Node);
			} else if (ElementID.toUpperCase() == "TYPE") {
				Type = ElementValue;
			} else if (ElementID.toUpperCase() == "LABEL") {
				Label = ElementValue;
			} else if (ElementID.toUpperCase() == "LEVELS") {
				MoreLevels = ElementValue;
			}
		}
	}
	for (LevelID = MaxLevelID + 1; LevelID < MinLevelID + MoreLevels; LevelID ++)
		Levels[LevelID] = Levels[MaxLevelID];
	if (Levels.length > 0) {
		// Process POIs for each layer
		for (LevelID in Levels) {
			//StatusMessage("Processing line " + SourceObjectLineNum + ": Exporting POI at level " + LevelID + "...");
			for (NodeID in Levels[LevelID])
				ProcessPoint(MapInfo, Levels[LevelID][NodeID], "10", Type, LevelID, Label, SourceObjectLineNum, DestinationFolderName);
		}
		POIsProcessed++;
	} else
		ErrorMessage("Error: POI at line " + SourceObjectLineNum + " is fake");
}
//-------------------------------------------
function ProcessCityPointSection(MapInfo, SourceSection, SourceObjectLineNum, DestinationFolderName) {
	var ElementNum, EquationSignIndex, ElementID, ElementValue, LevelID, MinLevelID, MaxLevelID, Node;
	var Latitude, Longitude, Type, Label, MoreLevels, NodeID;

	Label = "";
	Levels = new Array();
	for (ElementNum = 1; ElementNum < SourceSection.length - 1; ElementNum++) {
		//StatusMessage("Processing line " + SourceObjectLineNum + ": Importing block (" + (ElementNum + 1) + "/" + SourceSection.length + ")...");
		EquationSignIndex = SourceSection[ElementNum].indexOf("=");
		if (EquationSignIndex != -1) {
			ElementID = Trim(SourceSection[ElementNum].substr(0, EquationSignIndex));
			ElementValue = Trim(SourceSection[ElementNum].substring(EquationSignIndex + 1, SourceSection[ElementNum].length));
			if (ElementID.substr(0, 4).toUpperCase() == "DATA"
			|| ElementID.substr(0, 6).toUpperCase() == "ORIGIN") {
				LevelID = parseInt(ElementID.substring((ElementID.substr(0, 6).toUpperCase() == "ORIGIN" ? 6 : 4), ElementID.length));
				MinLevelID = MinLevelID == undefined ? LevelID : Math.min(MinLevelID, LevelID);
				MaxLevelID = MaxLevelID == undefined ? LevelID : Math.max(MaxLevelID, LevelID);
				Node = ImportNode(ElementValue);
				if (Levels[LevelID] == undefined)
					Levels[LevelID] = new Array();
				Levels[LevelID].push(Node);
			} else if (ElementID.toUpperCase() == "TYPE") {
				Type = ElementValue;
			} else if (ElementID.toUpperCase() == "LABEL") {
				Label = ElementValue;
			} else if (ElementID.toUpperCase() == "LEVELS") {
				MoreLevels = ElementValue;
			}
		}
	}
	for (LevelID = MaxLevelID + 1; LevelID < MinLevelID + MoreLevels; LevelID ++)
		Levels[LevelID] = Levels[MaxLevelID];
	if (Levels.length > 0) {
		// Process cilies/points for each layer
		for (LevelID in Levels) {
			//StatusMessage("Processing line " + SourceObjectLineNum + ": Exporting City/Point at level " + LevelID + "...");
			for (NodeID in Levels[LevelID])
				ProcessPoint(MapInfo, Levels[LevelID][NodeID], "20", Type, LevelID, Label, SourceObjectLineNum, DestinationFolderName);
		}
		CitiesPointsProcessed++;
	} else
		ErrorMessage("Error: City/Point at line " + SourceObjectLineNum + " is fake");
}
//-------------------------------------------
function ProcessPolylineSection(MapInfo, SourceSection, SourceObjectLineNum, DestinationFolderName) {
	var Levels, ElementNum, EquationSignIndex, ElementID, ElementValue;
	var LevelID, MinLevelID, MaxLevelID, Line, Type, Label, MoreLevels, Centroid;

	Label = "";
	Levels = new Array();
	for (ElementNum = 1; ElementNum < SourceSection.length - 1; ElementNum++) {
		//StatusMessage("Processing line " + SourceObjectLineNum + ": Importing block (" + (ElementNum + 1) + "/" + SourceSection.length + ")...");
		EquationSignIndex = SourceSection[ElementNum].indexOf("=");
		if (EquationSignIndex != -1) {
			ElementID = Trim(SourceSection[ElementNum].substr(0, EquationSignIndex));
			ElementValue = Trim(SourceSection[ElementNum].substring(EquationSignIndex + 1, SourceSection[ElementNum].length));
			if (ElementID.substr(0, 4).toUpperCase() == "DATA") {
				LevelID = parseInt(ElementID.substring(4, ElementID.length));
				MinLevelID = MinLevelID == undefined ? LevelID : Math.min(MinLevelID, LevelID);
				MaxLevelID = MaxLevelID == undefined ? LevelID : Math.max(MaxLevelID, LevelID);
				if (Levels[LevelID] == undefined)
					Levels[LevelID] = new Array();
				Line = ImportLine(ElementValue);
				Line.SourceSections = new Array();
				Line.SourceSections.push(Levels[LevelID].length + 1);
				Levels[LevelID].push(Line);
			} else if (ElementID.toUpperCase() == "TYPE") {
				Type = ElementValue;
			} else if (ElementID.toUpperCase() == "LABEL") {
				Label = ElementValue;
			} else if (ElementID.toUpperCase() == "LEVELS") {
				MoreLevels = ElementValue;
			}
		}
	}
	for (LevelID = MaxLevelID + 1; LevelID < MinLevelID + MoreLevels; LevelID ++)
		Levels[LevelID] = Levels[MaxLevelID];
	if (Levels.length > 0) {
		// Process cilies/points for each layer
		for (LevelID in Levels) {
			//StatusMessage("Processing line " + SourceObjectLineNum + ": Exporting polyline at level " + LevelID + "...");
			ProcessPolyline(MapInfo, Levels[LevelID], "40", Type, LevelID, Label, SourceObjectLineNum, DestinationFolderName);
		}
		PolylinesProcessed++;
	} else
		ErrorMessage("Error: Polyline at line " + SourceObjectLineNum + " is fake");
}
//-------------------------------------------
function ProcessRegionSection(MapInfo, SourceSection, SourceObjectLineNum, DestinationFolderName) {
	var Levels, ElementNum, EquationSignIndex, ElementID, ElementValue;
	var LevelID, MinLevelID, MaxLevelID, Line, Type, Label, MoreLevels, Centroid;

	Label = "";
	Levels = new Array();
	for (ElementNum = 1; ElementNum < SourceSection.length - 1; ElementNum++) {
		//StatusMessage("Processing line " + SourceObjectLineNum + ": Importing block (" + (ElementNum + 1) + "/" + SourceSection.length + ")...");
		EquationSignIndex = SourceSection[ElementNum].indexOf("=");
		if (EquationSignIndex != -1) {
			ElementID = Trim(SourceSection[ElementNum].substr(0, EquationSignIndex));
			ElementValue = Trim(SourceSection[ElementNum].substring(EquationSignIndex + 1, SourceSection[ElementNum].length));
			if (ElementID.substr(0, 4).toUpperCase() == "DATA") {
				LevelID = parseInt(ElementID.substring(4, ElementID.length));
				MinLevelID = MinLevelID == undefined ? LevelID : Math.min(MinLevelID, LevelID);
				MaxLevelID = MaxLevelID == undefined ? LevelID : Math.max(MaxLevelID, LevelID);
				if (Levels[LevelID] == undefined)
					Levels[LevelID] = new Array();
				Polygon = ImportPolygon(ElementValue);
				Polygon.SourcePolygons = new Array();
				Polygon.SourcePolygons.push(Levels[LevelID].length + 1);
				Levels[LevelID].push(Polygon);
			} else if (ElementID.toUpperCase() == "TYPE") {
				Type = ElementValue;
			} else if (ElementID.toUpperCase() == "LABEL") {
				Label = ElementValue;
			} else if (ElementID.toUpperCase() == "LEVELS") {
				MoreLevels = ElementValue;
			}
		}
	}
	for (LevelID = MaxLevelID + 1; LevelID < MinLevelID + MoreLevels; LevelID ++)
		Levels[LevelID] = Levels[MaxLevelID];
	if (Levels.length > 0) {
		// Process regions for each layer
		for (LevelID in Levels) {
			//StatusMessage("Processing line " + SourceObjectLineNum + ": Exporting region at level " + LevelID + "...");
			ProcessRegion(MapInfo, Levels[LevelID], "80", Type, LevelID, Label, SourceObjectLineNum, DestinationFolderName);
		}
		RegionsProcessed++;
	} else
		ErrorMessage("Error: Region at line " + SourceObjectLineNum + " is fake");
}
//-------------------------------------------
function ProcessSection(MapInfo, SourceSection, SourceObjectLineNum, DestinationFolderName) {

	if (SourceSection[0].substr(0, 8).toUpperCase() == "[MAP]") {
		// Section represents map block header
	} else if (SourceSection[0].substr(0, 8).toUpperCase() == "[IMG ID]") {
		// Section represents map block header
		ProcessImgSection(MapInfo, SourceSection, SourceObjectLineNum);
	} else if (SourceSection[0].substr(0, 7).toUpperCase() == "[RGN10]") {
		// Section represents POI
		ProcessPOISection(MapInfo, SourceSection, SourceObjectLineNum, DestinationFolderName);
	} else if (SourceSection[0].substr(0, 7).toUpperCase() == "[RGN20]") {
		// Section represents City or Point
		ProcessCityPointSection(MapInfo, SourceSection, SourceObjectLineNum, DestinationFolderName);
	} else if (SourceSection[0].substr(0, 7).toUpperCase() == "[RGN40]") {
		// Section represents polyline
		ProcessPolylineSection(MapInfo, SourceSection, SourceObjectLineNum, DestinationFolderName);
	} else if (SourceSection[0].substr(0, 7).toUpperCase() == "[RGN80]") {
		// Section represents region
		ProcessRegionSection(MapInfo, SourceSection, SourceObjectLineNum, DestinationFolderName);
	} else
		ErrorMessage("Error: Section type " + SourceSection[0] + " (line " + SourceObjectLineNum + ") not supported. Section ignored.");
}
//-------------------------------------------
function CloseDestinationFiles(MapInfo) {
	var TableName;

	MapInfo.Do("UnDim pmf2mi_Obj");
	for (TableName in CreatedTables)
		if (CreatedTables[TableName] != 0)
			MapInfo.Do("Commit Table " + TableName);
	//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	// Open tables in a map in correct order and with correct labels, hide all levels above lowest one
}
//-------------------------------------------
function ProcessFile(SourceFileName, DestinationFolderName) {
	var StartDate, EndDate, TimeElapsed;
	var SourceFile, SourceLine, BlockStarted, SourceBlock;
	var MapInfo, LineNum, SourceObjectLineNum;
	
	SectionsProcessed = 0;
	POIsProcessed = 0;
	CitiesPointsProcessed = 0;
	PolylinesProcessed = 0;
	RegionsProcessed = 0;
	NodesProcessed = 0;
	
	StartDate = new Date();

	SourceFile = fso.OpenTextFile(SourceFileName, ForReading);

	StatusMessage("Starting MapInfo...");
	try {
		MapInfo = GetObject("" , "MapInfo.Application");
	} catch (Exception) {
		ErrorMessage("Error: Cannot connect to MapInfo. Probably it is not opened.");
		SourceFile.Close();
		return;
	} finally {}

	try {
		MapInfo.Do("Dim pmf2mi_Obj As Object");
	} catch (Exception) {
		MapInfo.Do("UnDim pmf2mi_Obj");
		MapInfo.Do("Dim pmf2mi_Obj As Object");
	} finally {}

	BlockStarted = false;
	while (!SourceFile.AtEndOfStream) {

		SourceLine = SourceFile.ReadLine();
		if (!BlockStarted) {
			StatusMessage("Processing line " + SourceFile.Line + "...");
			if (SourceLine.charAt(0) == "[") {
				SourceBlock = new Array();
				SourceBlock.push(SourceLine);
				SourceObjectLineNum = SourceFile.Line - 1;
				BlockStarted = true;
			}
		} else {
			//StatusMessage("Processing line " + SourceObjectLineNum + ": Reading block (" + SourceBlock.length + ")...");
			SourceBlock.push(SourceLine);
			if (SourceLine.charAt(0) == "[") {
				ProcessSection(MapInfo, SourceBlock, SourceObjectLineNum, DestinationFolderName);
				SectionsProcessed++;
				BlockStarted = false;
			}
		}
	}
	
	SourceFile.Close();
	CloseDestinationFiles(MapInfo);
	
	EndDate = new Date();
	TimeElapsed = new Date(EndDate.valueOf() - StartDate.valueOf());
	
	InfoMessage("" + SectionsProcessed + "\tsections processed\n"
	+ POIsProcessed + "\tPOIs processed\n"
	+ CitiesPointsProcessed + "\tcities/points processed\n"
	+ PolylinesProcessed + "\tpolylines processed\n"
	+ RegionsProcessed + "\tregions processed\n"
	+ NodesProcessed + "\tnodes processed\n"
	+ TimeElapsed.getUTCHours() + ":" + FillLeft(TimeElapsed.getUTCMinutes(), 2, "0") + ":" + FillLeft(TimeElapsed.getUTCSeconds(), 2, "0") + "\telapsed\n"
	+ (SectionsProcessed * 60000 / TimeElapsed.valueOf()).toFixed(0) + "\tsections per minute\n"
	+ (NodesProcessed * 1000 / TimeElapsed.valueOf()).toFixed(0) + "\tnodes per second");
}
//-------------------------------------------
function CommandLineMode() {
	return fso.GetBaseName(WScript.FullName).toUpperCase() == "CSCRIPT";
}
//-------------------------------------------
var SourceFileName = "", DestinationFolderName = "";
var CutFileName;
var ArgumentNum, Argument, CommandLineSyntaxIsCorrect = true, EqualSighIndex, SwitchName, SwitchValue;

if (5.5 > WScript.Version) {
	WScript.Echo(sSplash + "\nError: Windows Script Host 5.5 required.\nDownload and install latest Windows Script Host version from www.microsoft.com.");
} else {

	for (ArgumentNum = 0; ArgumentNum < WScript.Arguments.Count(); ArgumentNum++) {
		Argument = WScript.Arguments(ArgumentNum);
		if (Argument.substr(0, 1) != "-" && Argument.substr(0, 1) != "/")
			if (SourceFileName == "")
				SourceFileName = Argument;
			else if (DestinationFolderName == "")
				DestinationFolderName = Argument;
			else
				CommandLineSyntaxIsCorrect = false;
		else {
			EqualSighIndex = Argument.indexOf("=");
			SwitchName = (EqualSighIndex == -1 ? Argument.substring(1, Argument.length) : Argument.substring(1, EqualSighIndex)).toLowerCase();
			SwitchValue = EqualSighIndex == -1 ? true : Argument.substring(EqualSighIndex + 1, Argument.length);
			CommandLineSyntaxIsCorrect = false;
		}
	}
	
	if (SourceFileName == "")
		CommandLineSyntaxIsCorrect = false;
		
	if (DestinationFolderName == "")
		DestinationFolderName = ".";

	if (!CommandLineSyntaxIsCorrect)
		WScript.Echo(sHelp);
	else {
		if (CommandLineMode())
			WScript.StdOut.WriteLine(sSplash);
		// Process arguments
		ProcessFile(SourceFileName, DestinationFolderName);
	}
}
